#include<iostream>
#include<vector>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

std::vector<int> solve(std::vector<int> A) {
    ll sum = 0;
    int N = A.size();
    vector<bool> used(N, false);
    vector<int> divide;
    int num_packs = (N+1)/2;
    int st = (N + 2)/4;
    int last_idx = A[st];
    for (int i = 0; i < num_packs; i++) {
        divide.push_back(i+st);
        used[i+st] = true;
    }
    
    for (int i = 0; i < N; i++) {
        if (!used[i]) divide.push_back(i);
    }    
    return divide;
}

// int main () {
//     ios_base::sync_with_stdio(false);
//     cin.tie(NULL);
//     int t;
//     cin >> t ;
//     for (int test=1; test<=t; test++) {
//         int n;
//         cin >> n ;
//         vector <int> a(n);
//         for (int i=0; i<n; i++) {
//             cin >> a[i] ;
//         }

//         for (auto ind : solve(a)) {
//             cout << ind << " ";
//         }
//         cout << endl ;
//     }
//     cout << endl ;
//     return 0;
// }